package net.minecraft.src;

import java.util.ArrayList;
import java.util.Map;

import net.minecraft.server.MinecraftServer;

// SDK
public class mod_SdkUtility extends BaseMod
{
    public static final Item itemGoldCoin = (new Item(2509)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20105_a("goldCoin");
    public static final Item itemLightometer = (new Item(2510)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20105_a("lightometer");
    public static final Item itemNightvisionGoggles = (new ItemArmor(2513, -1, 0, 0)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20105_a("nightvisionGoggles");
    public static final Item itemScubaTank = (new ItemArmor(2521, -1, 0, 1)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20105_a("scubaTank");
    public static final Item itemParachute = (new SdkItemParachute(2523, 0)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).func_20105_a("parachute");
	
	public mod_SdkUtility()
    {
		ModLoader.RegisterEntityID(SdkEntityParachute.class, "Parachute", ModLoader.getUniqueEntityId());
    }
	
	@Override
	public String Version()
	{
		return "1.2_02v1.1";
	}
	
	@Override
	public void Tick(MinecraftServer minecraftServer)
	{
		for(EntityPlayerMP e : new ArrayList<EntityPlayerMP>(minecraftServer.configManager.playerEntities))
		{
			ItemStack itemstack = e.inventory.armorInventory[2];
	        if(itemstack != null && itemstack.itemID == itemScubaTank.swiftedIndex)
	        {
	        	e.air = e.maxAir;
	        }
		}
	}

	@Override
    public void AddRecipes(CraftingManager craftingmanager)
    {
		craftingmanager.func_20153_a(new ItemStack(itemGoldCoin, 4), new Object[] {
            "#", Character.valueOf('#'), Item.ingotGold
        });
		craftingmanager.func_20153_a(new ItemStack(itemLightometer, 1), new Object[] {
        	" # ", "#X#", " # ", Character.valueOf('#'), Item.ingotGold, Character.valueOf('X'), Item.lightStoneDust
        });
		craftingmanager.func_20153_a(new ItemStack(itemNightvisionGoggles, 1), new Object[] {
        	"#X#", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), Item.silk
        });
		craftingmanager.func_20153_a(new ItemStack(itemScubaTank, 1), new Object[] {
        	"###", "# #", "###", Character.valueOf('#'), Item.ingotIron
        });
		craftingmanager.func_20153_a(new ItemStack(itemParachute, 1), new Object[] {
        	"###", "XYX", "YYY", Character.valueOf('#'), Block.cloth, Character.valueOf('X'), Item.silk, Character.valueOf('Y'), Item.leather
        });
    }
	
	@Override
	public void AddEntityTrackers(Map<Class, SdkPair<Integer, Integer>> map)
	{
		map.put(SdkEntityParachute.class, new SdkPair<Integer, Integer>(160, 3));
	}
	
	@Override
	public void AddEntityTrackerEntries(Map<Class, Integer> map)
	{
		map.put(SdkEntityParachute.class, 120);
	}
	
	@Override
	public boolean HandlePacket(Packet200ModLoader packet200ModLoader, EntityPlayerMP entityPlayerMp)
	{
		if(packet200ModLoader.id == 123456789 && packet200ModLoader.dataInt[0] == 1)
		{
			handleParachuteKey(entityPlayerMp);
			return true;
		}
		
		return false;
	}
	
	public static void handleParachuteKey(EntityPlayer entityPlayer)
	{
		ItemStack itemstack = entityPlayer.inventory.armorInventory[2];
		
		if(itemstack != null && itemstack.itemID == itemParachute.swiftedIndex)
		{
			itemstack.useItemRightClick(ModLoader.getMinecraftServerInstance().worldMngr, entityPlayer);
		}
	}
}
